package ch.zhaw.gartenverwaltung.notifier;

import ch.zhaw.gartenverwaltung.models.GardenSchedule;
import ch.zhaw.gartenverwaltung.types.Task;

import java.io.IOException;
import java.time.LocalDate;
import java.util.function.Consumer;

public class Notifier implements Runnable{
    private final GardenSchedule gardenSchedule;
    private boolean interrupted = false;

    public Notifier(GardenSchedule gardenSchedule) {
        this.gardenSchedule = gardenSchedule;
    }

    private void sendNotification(Task task){
        // TODO implement
    }

    private void sendNotifications(){
        System.out.println("sending Notifications");
        try {
            gardenSchedule.getTaskList().forEach(task -> {
                if(task.getNextNotification() != null && task.getNextNotification().isBefore(LocalDate.now().minusDays(1))){
                    sendNotification(task);
                    task.setNextNotification(task.getNextExecution());
                }
            });
        } catch (IOException e) {
            // TODO Logger
            e.printStackTrace();
        }
    }

    @Override
    public void run() {
        while(!interrupted){
            try {
                sendNotifications();
                Thread.sleep(3000);
            } catch (InterruptedException e) {
                interrupted = true;
            }
        }
    }
}
